<template>
  <main>
    <mt-page-title :with-border="false" :with-padding="true">
      <h1 class="has-text-weight-bold is-size-3">Liste des pax de mon unité</h1>
    </mt-page-title>
    <mt-box padding="0">
      <header class="mt-box-header">
        <b-field>
          <b-autocomplete
            class="mt-auto-complete-border-less"
            :data="data"
            placeholder="Rechercher une personne"
            icon="magnify"
            clearable
            :loading="isFetching"
            @typing="getAsyncData"
            @select="selectAutoComplete"
          >
            <template #empty>aucun résultat</template>
            <template #default="{ option }">
              <article class="columns is-mobile ">
                <div v-if="!isEmploye" class="column ">
                  <nuxt-link :to="profilLink({ name: 'pax-id-utilisateur', params: { id: option.id } })">
                    <mt-utilisateur :utilisateur="option" />
                  </nuxt-link>
                </div>
                <div v-else class="column" @click="ouvreInfoPerso(option)">
                  <mt-utilisateur :utilisateur="option" />
                </div>
              </article>
            </template>
          </b-autocomplete>
        </b-field>
      </header>
      <article class="mt-box-content">
        <mt-filtre-categorie
          :libelle-total="libeleTotal"
          :fullsize="pax.fullsize"
          :categories="pax.corps"
          :groupes="groupes"
          :groupe-selected="groupeSelected"
          afficher-total
          @select-all="viderFiltre"
          @select-categorie="filtreCategorie"
          @select-groupe="filtrerGroupe"
          @unselect-groupe="unfiltrerGroupe"
        ></mt-filtre-categorie>
        <mt-list v-slot="{ item: pa }" :list="pax.filtrer">
          <mt-list-item :class="{ 'mt-list-item-selected': pa.id === utilisateur.id }">
            <div class="columns is-vcentered">
              <div class="columns column mt-marginless-bottom">
                <div v-if="!isEmploye || isSuperEmploye" class="column">
                  <nuxt-link :to="profilLink({ name: 'pax-id-utilisateur', params: { id: pa.id } })">
                    <mt-utilisateur :utilisateur="pa"><b-icon v-if="!pa.enabled" icon="lock"/></mt-utilisateur>
                  </nuxt-link>
                </div>
                <div v-else class="column" @click="ouvreInfoPerso(pa)">
                  <mt-utilisateur :utilisateur="pa" is-clickable
                    ><b-icon v-if="!pa.enabled" icon="lock"
                  /></mt-utilisateur>
                </div>
                <div class="column is-narrow is-flex">
                  <mt-groupes :groupes="pa.groupes" :limit="2"></mt-groupes>
                </div>
              </div>
            </div>
          </mt-list-item>
        </mt-list>
      </article>
    </mt-box>
    <mt-infos-perso :ouvert.sync="ouvert" :utilisateur="utilisateurSelected" :organismes="organismes"></mt-infos-perso>
  </main>
</template>

<script>
import debounce from 'lodash/debounce';
import MtPageTitle from '~/components/base/page-title/index';
import MtList from '~/components/base/list/index';
import MtListItem from '~/components/base/list/list-item';
import MtBox from '~/components/base/box';
import MtFiltreCategorie from '~/components/filtre/filtre-categorie/index';
import MtUtilisateur from '~/components/pax/mt-utilisateur';
import userMixin from '~/components/mixins/userMixin';
import MtInfosPerso from '~/components/pax/mt-infos-perso';
import MtGroupes from '~/components/pax/mt-groupes';

export default {
  components: {
    MtGroupes,
    MtInfosPerso,
    MtUtilisateur,
    MtFiltreCategorie,
    MtPageTitle,
    MtList,
    MtListItem,
    MtBox,
  },
  mixins: [userMixin],
  data() {
    return {
      idCorps: null,
      filtre: '',
      isFetching: false,
      selected: null,
      data: [],
      ouvert: false,
      utilisateurSelected: {},
      organismes: [],
      groupeSelected: null,
      libeleTotal: 'TOTAL DES PAX',
    };
  },
  computed: {
    idGroupeSelected() {
      if (this.groupeSelected) {
        return this.groupeSelected.id;
      }
      return null;
    },
  },
  watch: {
    organisme: {
      handler() {
        this.refresh();
      },
      immediate: true,
    },
  },
  async asyncData({ $api }) {
    const pax = await $api.organisme().utilisateursFilterWithMyGroupesAndNoEnabled();
    const groupes = await $api.utilisateur().groupes();
    return {
      pax,
      groupes,
    };
  },
  methods: {
    filtrerGroupe(groupe) {
      this.groupeSelected = groupe;
      this.refresh();
    },
    unfiltrerGroupe() {
      this.groupeSelected = null;
      this.refresh();
    },
    selectAutoComplete(option) {
      this.selected = option;
    },
    async refresh() {
      this.pax = await this.$api
        .organisme()
        .utilisateursFilterWithMyGroupesAndNoEnabled(this.idCorps, this.idGroupeSelected);
    },
    filtreCategorie(corps) {
      this.idCorps = corps.id;
      this.refresh();
    },
    viderFiltre() {
      this.idCorps = null;
      this.refresh();
    },
    async ouvreInfoPerso(utilisateur) {
      this.organismes = await this.$api
        .organisme(this.getIdOrganisme(utilisateur))
        .organismesByEnfantOrderByHierarchie();
      this.ouvert = true;
      this.utilisateurSelected = utilisateur;
    },
    getIdOrganisme({
      affectation: {
        organisme: { id },
      },
    }) {
      return id;
    },
    getAsyncData: debounce(async function getAsyncData(search) {
      this.isFetching = true;
      try {
        if (search != null && search.length > 0) {
          this.data = await this.$api.organisme().rechercheUtilisateurs(search);
        } else {
          this.data = [];
        }
      } catch (e) {
        this.$buefy.toast.open({
          message: 'Une erreur est survenue lors de la récupération des données.',
          type: 'is-danger',
        });
      } finally {
        this.isFetching = false;
      }
    }, 500),
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-filter-liste {
  display: flex;
  justify-content: space-between;
  margin-top: 1rem;
  .mt-filter-liste-groupe {
    display: flex;
  }

  /deep/ .mt-filter-item {
    border-radius: 2rem;
    background-color: $pale-grey;
    color: #666ee8;
    font-size: $size-7;
    padding: 0.5em 1em;
    margin: 0 0.25em;

    text-align: center;
    cursor: pointer;
    transition-property: background-color, color;
    transition-duration: 0.3s;

    &.selected,
    &.selected:hover {
      background-color: $periwinkle-blue;
      color: $white;
    }
  }
}
.link {
  font-weight: bold;
  color: $soft-blue;
  &:hover {
    color: $periwinkle-blue;
  }
}
/deep/ .mt-auto-complete-border-less {
  input {
    border-style: none;
    box-shadow: none;
  }
}
/deep/ .control.has-icons-left .icon {
  color: $brown-grey;
}
</style>
